package istia.st.springmvc.exemples.web;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import istia.st.springmvc.exemples.metier.IMetier;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.multiaction.MultiActionController;

public class MyMultiActionController extends MultiActionController {

	// couche mtier
	IMetier metier;

	public IMetier getMetier() {
		return metier;
	}

	public void setMetier(IMetier metier) {
		this.metier = metier;
	}

	// liste des noms
	public ModelAndView list(HttpServletRequest request,
			HttpServletResponse response) {
		// on demande les noms  la couche [mtier]
		List noms = metier.getAll();
		// on les met dans le modle de la vue
		Map modle = new HashMap();
		modle.put("noms", noms);
		// on rend le nom de la vue et son modle
		return new ModelAndView("list", modle);
	}

	// supprimer des noms
	public ModelAndView delete(HttpServletRequest request,
			HttpServletResponse response) {
		// liste des noms slectionn dans la liste
		String[] noms = request.getParameterValues("noms");
		// on demande  la couche [mtier] de les supprimer de la liste existante
		metier.delete(Arrays.asList(noms));
		// on rend le nom de la vue et son modle
		return list(request,response);
	}

	// ajouter des noms
	public ModelAndView add(HttpServletRequest request,
			HttpServletResponse response) {
		// chane des noms  ajouter
		String nouveaux = request.getParameter("nouveaux");
		// ces noms sont mis dans un tableau
		String[] nouveauxNoms = nouveaux.split("\r\n");
		// on cre la liste des noms  ajouter
		ArrayList alNouveauxNoms = new ArrayList();
		String nouveauNom;
		for (int i = 0; i < nouveauxNoms.length; i++) {
			// on ne garde le nom que s'il est non vide
			nouveauNom = nouveauxNoms[i].trim();
			if (nouveauNom.length() != 0) {
				alNouveauxNoms.add(nouveauNom);
			}
		}
		// on demande  la couche [mtier] de les ajouter  la liste existante
		if (alNouveauxNoms.size() != 0) {
			metier.add(alNouveauxNoms);
		}
		// on rend le nom de la vue et son modle
		return list(request, response);
	}
}
