package istia.st.springmvc.exemples.web;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractWizardFormController;

public class AssistantController extends AbstractWizardFormController {

	protected ModelAndView processFinish(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {
		// confirmation des saisies
		Map modle=new HashMap();
		modle.put("formulaire",command);
		return new ModelAndView("validation",modle);
		}

	protected ModelAndView processCancel(HttpServletRequest request,
            HttpServletResponse response,
            Object command,
            BindException errors)
     throws Exception{
		// retour  la case dpart
		return new ModelAndView("index");
	}
	
	// validation d'une page
	protected void validatePage(Object formulaire, Errors errors, int page) {
		// on rcupre le formulaire
		Formulaire form=(Formulaire)formulaire;
		// quelle page ?
		switch (page) {
		case 0:
			validatePage0(form, errors);
			break;
		case 1:
			validatePage1(form, errors);
			break;
		}
	}

	// validation page 0
	private void validatePage0(Formulaire form, Errors errors) {
		// le nom doit tre non vide
		String nom=form.getNom();
		if(nom==null || nom.trim().length()==0){
			errors.rejectValue("nom","formulaire.nom.obligatoire");
		}
	}

	// validation page 1
	private void validatePage1(Formulaire form, Errors errors) {
		// l'ge doit tre positif
		int age=form.getAge();
		if(age<1 || age>150){
			errors.rejectValue("age","formulaire.age.invalide", new String[]{"1","150"},"Donne invalide");
		}
	}
}
