package istia.st.springmvc.exemples.web;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.hssf.util.Region;
import org.springframework.web.servlet.view.document.AbstractExcelView;

public class ExcelView extends AbstractExcelView {

	protected void buildExcelDocument(Map modle, HSSFWorkbook classeur,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		// on rcupre le formulaire dans le modle
		Formulaire form = (Formulaire) modle.get("formulaire");
		// on cre une feuille dans le classeur
		HSSFSheet feuille = classeur.createSheet("confirmation");
		// les polices de caractres
		// font 0
		HSSFFont font0 = classeur.createFont();
		font0.setFontHeightInPoints((short) 24);
		font0.setFontName("Garamond");
		font0.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
		// font 1
		HSSFFont font1 = classeur.createFont();
		font1.setFontHeightInPoints((short) 12);
		font1.setFontName("Garamond");
		font1.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
		// font 2
		HSSFFont font2 = classeur.createFont();
		font2.setFontHeightInPoints((short) 12);
		font2.setFontName("Garamond");
		font2.setBoldweight(HSSFFont.BOLDWEIGHT_NORMAL);

		// les styles utiliss
		// style 0
		HSSFCellStyle style0 = classeur.createCellStyle();
		style0.setAlignment(HSSFCellStyle.ALIGN_CENTER);
		style0.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
		style0.setFillForegroundColor(HSSFColor.LIGHT_GREEN.index);
		style0.setFont(font0);
		// style 1
		HSSFCellStyle style1 = classeur.createCellStyle();
		style1.setAlignment(HSSFCellStyle.ALIGN_CENTER);
		style1.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
		style1.setFillForegroundColor(HSSFColor.LIGHT_ORANGE.index);
		style1.setFont(font1);
		// style 2
		HSSFCellStyle style2 = classeur.createCellStyle();
		style2.setAlignment(HSSFCellStyle.ALIGN_CENTER);
		style2.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
		style2.setFillForegroundColor(HSSFColor.LIGHT_BLUE.index);
		style2.setFont(font2);

		// contenu de la feuille
		// ligne 0
		int ligne = 0;
		HSSFCell cell = getCell(feuille, ligne, 0);
		cell.setCellValue("Confirmation de vos saisies");
		// cellule 0 tendue jusqu' la cellule 7
		feuille.addMergedRegion(new Region(0, (short) 0, 0, (short) 7));
		// style de la cellule 0
		cell.setCellStyle(style0);

		// ligne 2
		ligne += 2;
		cell = getCell(feuille, ligne, 0);
		cell.setCellValue("Nom");
		cell.setCellStyle(style1);
		cell = getCell(feuille, ligne, 1);
		cell.setCellValue("Age");
		cell.setCellStyle(style1);

		// ligne 3
		ligne++;
		cell = getCell(feuille, ligne, 0);
		cell.setCellValue(form.getNom());
		cell.setCellStyle(style2);
		cell = getCell(feuille, ligne, 1);
		cell.setCellValue(form.getAge());
		cell.setCellStyle(style2);
	}
}
